package v1

// DO NOT EDIT: this file is automatically generated by ./tools/generator in this repo

import (
	"encoding/json"
	"fmt"
	"log"

	"gitlab.com/signald/signald-go/signald"
)

// Submit: Accept a v2 group invitation. Note that you must have a profile name set to join groups.
func (r *AcceptInvitationRequest) Submit(conn *signald.Signald) (response JsonGroupV2Info, err error) {
	r.Version = "v1"
	r.Type = "accept_invitation"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: Link a new device to a local Signal account
func (r *AddLinkedDeviceRequest) Submit(conn *signald.Signald) (err error) {
	r.Version = "v1"
	r.Type = "add_device"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	return err

}

// Submit: approve a request to join a group
func (r *ApproveMembershipRequest) Submit(conn *signald.Signald) (response JsonGroupV2Info, err error) {
	r.Version = "v1"
	r.Type = "approve_membership"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

func (r *CreateGroupRequest) Submit(conn *signald.Signald) (response JsonGroupV2Info, err error) {
	r.Version = "v1"
	r.Type = "create_group"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: delete all account data signald has on disk, and optionally delete the account from the server as well. Note that this is not "unlink" and will delete the entire account, even from a linked device.
func (r *DeleteAccountRequest) Submit(conn *signald.Signald) (err error) {
	r.Version = "v1"
	r.Type = "delete_account"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	return err

}

func (r *FinishLinkRequest) Submit(conn *signald.Signald) (response Account, err error) {
	r.Version = "v1"
	r.Type = "finish_link"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: Generate a linking URI. Typically this is QR encoded and scanned by the primary device. Submit the returned session_id with a finish_link request.
func (r *GenerateLinkingURIRequest) Submit(conn *signald.Signald) (response LinkingURI, err error) {
	r.Version = "v1"
	r.Type = "generate_linking_uri"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: Query the server for the latest state of a known group
func (r *GetGroupRequest) Submit(conn *signald.Signald) (response JsonGroupV2Info, err error) {
	r.Version = "v1"
	r.Type = "get_group"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: Get information about a known keys for a particular address
func (r *GetIdentitiesRequest) Submit(conn *signald.Signald) (response IdentityKeyList, err error) {
	r.Version = "v1"
	r.Type = "get_identities"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: list all linked devices on a Signal account
func (r *GetLinkedDevicesRequest) Submit(conn *signald.Signald) (response LinkedDevices, err error) {
	r.Version = "v1"
	r.Type = "get_linked_devices"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: Get all information available about a user
func (r *GetProfileRequest) Submit(conn *signald.Signald) (response Profile, err error) {
	r.Version = "v1"
	r.Type = "get_profile"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: Join a group using the a signal.group URL. Note that you must have a profile name set to join groups.
func (r *JoinGroupRequest) Submit(conn *signald.Signald) (response JsonGroupJoinInfo, err error) {
	r.Version = "v1"
	r.Type = "join_group"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

func (r *LeaveGroupRequest) Submit(conn *signald.Signald) (response GroupInfo, err error) {
	r.Version = "v1"
	r.Type = "leave_group"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

func (r *ListContactsRequest) Submit(conn *signald.Signald) (response ProfileList, err error) {
	r.Version = "v1"
	r.Type = "list_contacts"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

func (r *ListGroupsRequest) Submit(conn *signald.Signald) (response GroupList, err error) {
	r.Version = "v1"
	r.Type = "list_groups"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

func (r *MarkReadRequest) Submit(conn *signald.Signald) (err error) {
	r.Version = "v1"
	r.Type = "mark_read"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	return err

}

// Submit: react to a previous message
func (r *ReactRequest) Submit(conn *signald.Signald) (response SendResponse, err error) {
	r.Version = "v1"
	r.Type = "react"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: begin the account registration process by requesting a phone number verification code. when the code is received, submit it with a verify request
func (r *RegisterRequest) Submit(conn *signald.Signald) (response Account, err error) {
	r.Version = "v1"
	r.Type = "register"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: Remove a linked device from the Signal account. Only allowed when the local device id is 1
func (r *RemoveLinkedDeviceRequest) Submit(conn *signald.Signald) (err error) {
	r.Version = "v1"
	r.Type = "remove_linked_device"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	return err

}

// Submit: Resolve a partial JsonAddress with only a number or UUID to one with both. Anywhere that signald accepts a JsonAddress will except a partial, this is a convenience function for client authors, mostly because signald doesn't resolve all the partials it returns
func (r *ResolveAddressRequest) Submit(conn *signald.Signald) (response JsonAddress, err error) {
	r.Version = "v1"
	r.Type = "resolve_address"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

func (r *SendRequest) Submit(conn *signald.Signald) (response SendResponse, err error) {
	r.Version = "v1"
	r.Type = "send"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

func (r *SetProfile) Submit(conn *signald.Signald) (err error) {
	r.Version = "v1"
	r.Type = "set_profile"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	return err

}

// Submit: Trust another user's safety number using either the QR code data or the safety number text
func (r *TrustRequest) Submit(conn *signald.Signald) (err error) {
	r.Version = "v1"
	r.Type = "trust"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	return err

}

// Submit: modify a group. Note that only one modification action may be preformed at once
func (r *UpdateGroupRequest) Submit(conn *signald.Signald) (response GroupInfo, err error) {
	r.Version = "v1"
	r.Type = "update_group"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

// Submit: verify an account's phone number with a code after registering, completing the account creation process
func (r *VerifyRequest) Submit(conn *signald.Signald) (response Account, err error) {
	r.Version = "v1"
	r.Type = "verify"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}

func (r *VersionRequest) Submit(conn *signald.Signald) (response JsonVersionMessage, err error) {
	r.Version = "v1"
	r.Type = "version"
	if r.ID == "" {
		r.ID = signald.GenerateID()
	}
	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}

	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return
	}

	return response, nil

}
